diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/bindings/modulegen__gcc_LP64.py ns-3.31/src/fd-net-device/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/fd-net-device/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/fd-net-device/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -5171,32 +5209,32 @@
     cls.add_method('IsBridge', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::IsBroadcast() const [member function]
     cls.add_method('IsBroadcast', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::IsLinkUp() const [member function]
     cls.add_method('IsLinkUp', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::IsMulticast() const [member function]
     cls.add_method('IsMulticast', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::IsPointToPoint() const [member function]
     cls.add_method('IsPointToPoint', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::NeedsArp() const [member function]
     cls.add_method('NeedsArp', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): bool ns3::FdNetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
     cls.add_method('Send', 
                    'bool', 
@@ -5267,12 +5305,12 @@
     cls.add_method('SupportsSendFrom', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## fd-net-device.h (module 'fd-net-device'): void ns3::FdNetDevice::DoDispose() [member function]
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3FdNetDeviceFdReader_methods(root_module, cls):
@@ -5288,7 +5326,7 @@
     cls.add_method('DoRead', 
                    'ns3::FdReader::Data', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -5300,7 +5338,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -5310,7 +5348,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/dummy-network.cc ns-3.31/src/fd-net-device/examples/dummy-network.cc
--- ns-3.30.1/src/fd-net-device/examples/dummy-network.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/dummy-network.cc	2020-06-27 17:38:30.000000000 -0700
@@ -35,7 +35,7 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   NodeContainer nodes;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd2fd-onoff.cc ns-3.31/src/fd-net-device/examples/fd2fd-onoff.cc
--- ns-3.30.1/src/fd-net-device/examples/fd2fd-onoff.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd2fd-onoff.cc	2020-06-27 17:38:30.000000000 -0700
@@ -61,7 +61,7 @@
   // Command-line arguments
   //
   bool tcpMode = false;
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("tcpMode", "1:true, 0:false, default mode UDP",tcpMode);
   cmd.Parse (argc, argv);
    
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-emu-onoff.cc ns-3.31/src/fd-net-device/examples/fd-emu-onoff.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-emu-onoff.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-emu-onoff.cc	2020-06-27 17:38:30.000000000 -0700
@@ -106,7 +106,7 @@
   std::string macClient ("00:00:00:00:00:01");
   std::string macServer ("00:00:00:00:00:02");
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("deviceName", "Device name", deviceName);
   cmd.AddValue ("client", "Local IP address (dotted decimal only please)", client);
   cmd.AddValue ("server", "Remote IP address (dotted decimal only please)", server);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-emu-ping.cc ns-3.31/src/fd-net-device/examples/fd-emu-ping.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-emu-ping.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-emu-ping.cc	2020-06-27 17:38:30.000000000 -0700
@@ -98,7 +98,7 @@
   // Allow the user to override any of the defaults at run-time, via
   // command-line arguments
   //
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("deviceName", "Device name", deviceName);
   cmd.AddValue ("remote", "Remote IP address (dotted decimal only please)", remote);
   cmd.Parse (argc, argv);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-emu-udp-echo.cc ns-3.31/src/fd-net-device/examples/fd-emu-udp-echo.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-emu-udp-echo.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-emu-udp-echo.cc	2020-06-27 17:38:30.000000000 -0700
@@ -97,7 +97,7 @@
   // Allow the user to override any of the defaults at run-time, via command-line
   // arguments
   //
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("client", "client mode", clientMode);
   cmd.AddValue ("server", "server mode", serverMode);
   cmd.AddValue ("deviceName", "device name", deviceName);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-planetlab-ping.cc ns-3.31/src/fd-net-device/examples/fd-planetlab-ping.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-planetlab-ping.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-planetlab-ping.cc	2020-06-27 17:38:30.000000000 -0700
@@ -90,7 +90,7 @@
   // Allow the user to override any of the defaults at run-time, via
   // command-line arguments
   //
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("remote", "Remote IP address (dotted decimal only please)", remote);
   cmd.AddValue ("tapNetwork", "Network address to assign the TAP device IP address (dotted decimal only please). Note that the network address must be that from the vsys_vnet tag which must exist in your PlanetLab slice.", network);
   cmd.AddValue ("tapMask", "Network mask for configure the TAP device (dotted decimal only please)", mask);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-tap-ping6.cc ns-3.31/src/fd-net-device/examples/fd-tap-ping6.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-tap-ping6.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-tap-ping6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -60,7 +60,7 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   NS_LOG_INFO ("Ping6 Emulation Example with TAP");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/fd-tap-ping.cc ns-3.31/src/fd-net-device/examples/fd-tap-ping.cc
--- ns-3.30.1/src/fd-net-device/examples/fd-tap-ping.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/fd-tap-ping.cc	2020-06-27 17:38:30.000000000 -0700
@@ -103,7 +103,7 @@
   // Allow the user to override any of the defaults at run-time, via
   // command-line arguments
   //
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("deviceName", "Device name", deviceName);
   cmd.AddValue ("remote", "Remote IP address (dotted decimal only please)", remote);
   cmd.AddValue ("tapNetwork", "Network address to assign the TAP device IP address (dotted decimal only please)", network);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/realtime-dummy-network.cc ns-3.31/src/fd-net-device/examples/realtime-dummy-network.cc
--- ns-3.30.1/src/fd-net-device/examples/realtime-dummy-network.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/realtime-dummy-network.cc	2020-06-27 17:38:30.000000000 -0700
@@ -35,7 +35,7 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   GlobalValue::Bind ("SimulatorImplementationType", StringValue ("ns3::RealtimeSimulatorImpl"));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/examples/realtime-fd2fd-onoff.cc ns-3.31/src/fd-net-device/examples/realtime-fd2fd-onoff.cc
--- ns-3.30.1/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2020-06-27 17:38:30.000000000 -0700
@@ -56,7 +56,7 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   uint16_t sinkPort = 8000;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/helper/creator-utils.h ns-3.31/src/fd-net-device/helper/creator-utils.h
--- ns-3.30.1/src/fd-net-device/helper/creator-utils.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/helper/creator-utils.h	2020-06-27 17:38:30.000000000 -0700
@@ -20,6 +20,7 @@
 #define CREATOR_UTILS_H
 
 #include <unistd.h>
+#include <cstring>
 #include <string>
 #include <iostream>
 #include <iomanip>
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/fd-net-device/helper/tap-device-creator.cc ns-3.31/src/fd-net-device/helper/tap-device-creator.cc
--- ns-3.30.1/src/fd-net-device/helper/tap-device-creator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/fd-net-device/helper/tap-device-creator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,6 +22,7 @@
 #include <iostream>
 #include <iomanip>
 #include <sstream>
+#include <cstring>
 #include <stdlib.h>
 #include <errno.h>
 #include <fcntl.h>
